//  This file was generated by LevelHelper
//  http://www.levelhelper.org
//
//  LevelHelperLoader.h
//  Created by Bogdan Vladu
//  Copyright 2011 Bogdan Vladu. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
//
//  This software is provided 'as-is', without any express or implied
//  warranty.  In no event will the authors be held liable for any damages
//  arising from the use of this software.
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//  The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//  Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//  This notice may not be removed or altered from any source distribution.
//  By "software" the author refers to this code file and not the application 
//  that was used to generate this file.
//
////////////////////////////////////////////////////////////////////////////////

#import "LevelHelperLoader.h"

@interface LevelHelperLoader (CREATION_EXTENSION) 

//this will create a new sprite in the layer - no batch node
//BACKWARD COMPATIBILITY METHOD
-(LHSprite*) newSpriteWithUniqueName:(NSString*)name 
                        cocos2dLayer:(CCLayer*)cocosLayer; 

//example of use
/*
 NSArray* arr = [lh newSpritesWithTag:YOUR TAG cocos2dLayer:self];
 for(LHSprite* spr in arr){...}
 */
//pass nil to cocosLayer if you don't want to add the sprite to a layer
//-(NSArray*) newSpritesWithTag:(enum LevelHelper_TAG)tag
//				 cocos2dLayer:(CCLayer*)cocosLayer;
//------------------------------------------------------------------------------

//the LHSprite associated with the body will NOT use batch nodes
//pass nil to cocosLayer if you don't want to add the sprite to a layer
//BACKWARD COMPATIBILITY METHOD
-(b2Body*) newBodyWithUniqueName:(NSString*)name 
						   world:(b2World*)world 
					cocos2dLayer:(CCLayer*)cocosLayer;

//the LHSprite associated with the body will use batch nodes
//this method will also keep a reference to the body so it can be used with mouseJoints
//the uniqueName will be "uniqueName_LH_NEW_BODY_XX" (eg mySprite_LH_NEW_BODY_30)
//BACKWARD COMPATIBILITY METHOD
-(b2Body*) newBodyWithUniqueName:(NSString*)uniqueName 
						   world:(b2World*)world;


//example of use
/*
 NSArray* arr = [lh newBodiesWithTag:YOUR TAG world:world cocos2dLayer:self];
 for(NSValue* val in arr)
 {
 b2Body* body = [val pointerValue];
 ...
 }
 */
//pass nil to cocosLayer if you don't want to add the sprite to a layer
//-(NSArray*) newBodiesWithTag:(enum LevelHelper_TAG)tag 
//					   world:(b2World*)world 
//				cocos2dLayer:(CCLayer*)cocosLayer;

////////////////////////////////////////////////////////////////////////////////
@end	
