//  This file was generated by LevelHelper
//  http://www.levelhelper.org
//
//  LevelHelperLoader.h
//  Created by Bogdan Vladu
//  Copyright 2011 Bogdan Vladu. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
//
//  This software is provided 'as-is', without any express or implied
//  warranty.  In no event will the authors be held liable for any damages
//  arising from the use of this software.
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//  The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//  Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//  This notice may not be removed or altered from any source distribution.
//  By "software" the author refers to this code file and not the application 
//  that was used to generate this file.
//
////////////////////////////////////////////////////////////////////////////////

#import "LevelHelperLoader.h"
@interface LevelHelperLoader (SPRITE_INFO_EXTENSION) 

//this methods will return nil if fail
//use [sprite uniqueName]
+(NSString*) uniqueNameForSprite:(LHSprite*)sprite NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//use the sprite method instead. LHSprite is available in the body userData
+(NSString*) uniqueNameForBody:(b2Body*)body NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);

//value must be a NSObject type
//use methods availabel in LHSprite.h
+(void) setCustomValue:(id)value withKey:(NSString*)key onSprite:(LHSprite*)spritey NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
+(id) customValueWithKey:(NSString*)key forSprite:(LHSprite*)spritey NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//------------------------------------------------------------------------------
//use the class method availabel in LHSprite.h
+(bool) isLHSprite:(id)object NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//use the class method availabel in LHBezierNode.h
+(bool) isLHBezierNode:(id)object NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//------------------------------------------------------------------------------
//if fail will return -1
//use [sprite tag] instead
+(int) tagForSprite:(CCNode*)sprite NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//if fail will return -1
//use the class method available in LHSprite.h
+(int) tagForBody:(b2Body*)body NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//------------------------------------------------------------------------------
//use [sprite body] instead
+(b2Body*) bodyForSprite:(LHSprite*)spritey NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//if fail will return nil
//use the class method available in LHSprite.h
+(LHSprite*) spriteForBody:(b2Body*)body NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
//------------------------------------------------------------------------------

//example of use
/*
 NSArray* arr = [lh bodiesWithTag:YOUR TAG];
 for(NSValue* val in arr)
 {
 b2Body* body = [val pointerValue];
 ...
 }
 */
//The following methods should not be used anymore
//Use the LHSprite apropriate methods
-(NSArray*) bodiesWithTag:(enum LevelHelper_TAG)tag NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
-(b2Body*) bodyWithUniqueName:(NSString*)name NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);


-(bool) removeSpriteWithUniqueName:(NSString*)name NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
-(bool) removeBodyWithUniqueName:(NSString*)name NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);

-(bool) removeBody:(b2Body*)body NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
-(bool) removeBodiesWithTag:(enum LevelHelper_TAG)tag NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);
-(bool) removeAllBodies NS_DEPRECATED(10_0, 10_4, 2_0, 2_0);

@end	
