//  This file was generated by LevelHelper
//  http://www.levelhelper.org
//
//  LevelHelperLoader.h
//  Created by Bogdan Vladu
//  Copyright 2011 Bogdan Vladu. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
//
//  This software is provided 'as-is', without any express or implied
//  warranty.  In no event will the authors be held liable for any damages
//  arising from the use of this software.
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//  The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//  Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//  This notice may not be removed or altered from any source distribution.
//  By "software" the author refers to this code file and not the application 
//  that was used to generate this file.
//
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#include "Box2D.h"

@class LHSprite;
@interface LHAnimationNode : NSObject
{
    NSMutableString* uniqueName;
    NSMutableString* imageName;
    
    bool loop;
    float speed;
    int repetitions;
    bool startAtLaunch;

	NSMutableArray* frames;
    NSMutableArray* framesInfo;
    
    NSMutableString* imageFolder;
    CCSpriteBatchNode* batchNode; //week ptr
}
@property bool loop;
@property float speed;
@property int repetitions;
@property bool startAtLaunch;

-(id) initWithUniqueName:(NSString*)name;
+(id) animationNodeWithUniqueName:(NSString*)name;
////////////////////////////////////////////////////////////////////////////////
-(void) setImageFolder:(NSString*)folder;

-(void) setUniqueName:(NSString*)name;
-(NSString*)uniqueName;

-(NSString*)imageName;
-(void) setImageName:(NSString*)image;

-(void)setFramesInfo:(NSArray*)frmInfo;

-(void) computeFrames; //needs a valid batchNode and framesInfo
-(NSArray*)frames;

-(void) setBatchNode:(CCSpriteBatchNode*)node;

-(int) numberOfFrames;

//call setBatchNode then cumputeFrames first
-(void) runAnimationOnSprite:(LHSprite *)ccsprite 
           startingFromFrame:(int)startFrame //pass 0 if you want to start anim from start
             withNotifierObj:(id)animNotifierId 
                 notifierSel:(SEL)animNotifierSel 
                 notifOnLoop:(bool)notifOnLoop;

-(void) setAnimationTexturePropertiesOnSprite:(LHSprite*)ccsprite;
-(void) setFrame:(int)frameNo onSprite:(LHSprite*)spr;
@end	
