//  This file was generated by LevelHelper
//  http://www.levelhelper.org
//
//  LevelHelperLoader.h
//  Created by Bogdan Vladu
//  Copyright 2011 Bogdan Vladu. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
//
//  This software is provided 'as-is', without any express or implied
//  warranty.  In no event will the authors be held liable for any damages
//  arising from the use of this software.
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//  The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//  Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//  This notice may not be removed or altered from any source distribution.
//  By "software" the author refers to this code file and not the application 
//  that was used to generate this file.
//
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#include "Box2D.h"

@class LHSprite;
enum LH_JOINT_TYPE
{
	LH_DISTANCE_JOINT = 0,
	LH_REVOLUTE_JOINT,
	LH_PRISMATIC_JOINT,
	LH_PULLEY_JOINT,
	LH_GEAR_JOINT,
	LH_WHEEL_JOINT,
	LH_WELD_JOINT,
	LH_ROPE_JOINT,
	LH_FRICTION_JOINT,
    LH_UNKNOWN_TYPE
};

@interface LHJoint : NSObject
{
	b2Joint* joint; //week ptr
    
    NSString* uniqueName;
    NSMutableDictionary* customUserValues;
    
    int tag;
    LH_JOINT_TYPE type;
    
    bool shouldDistroyJointOnDealloc;
}
@property int tag;
@property enum LH_JOINT_TYPE type;

-(id) initWithUniqueName:(NSString*)name;
+(id) jointWithUniqueName:(NSString*)name;
////////////////////////////////////////////////////////////////////////////////
-(NSString*)uniqueName;

-(void) setJoint:(b2Joint*)jt;
-(b2Joint*)joint;
-(bool) removeJointFromWorld;

-(void) setCustomValue:(id)value withKey:(NSString*)key;
-(id) customValueWithKey:(NSString*)key;

-(LHSprite*) spriteA;
-(LHSprite*) spriteB;

+(bool) isLHJoint:(id)object;
+(LHJoint*) jointFromBox2dJoint:(b2Joint*)jt;
@end	
